iOS中预编译宏定义判断系统版本

先来两段代码:
片段1:

#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 50000
    //you can use iOS 5 APIs here because the SDK supports them
    //but the code may still crash if run on an iOS 4 device
#else
    //this code can’t use iOS 5 APIs as the SDK version doesn’t support them
#endif

片段2:

#if __IPHONE_OS_VERSION_MIN_REQUIRED >= 50000
    //minimum deployment target is 5.0, so it’s safe to use iOS 5-only code
#else
    //you can use iOS5 APIs, but the code will need to be backwards
    //compatible or it will crash when run on an iOS 4 device
#endif

如果碰到这个场景, 需要使用UIAlertViewController(iOS8+),我能用上述哪种写法呢? 答案是, 都不行.
max的取值来自于你的sdk的版本, 比如现在我的是Xcode6.1, SDK版本是iOS 8.1, 那么这个宏的值永远是80100, 也就是说, 会直接使用UIAlertViewController, 如果这个app跑在了iOS 7上, 就挂了. 所以单纯这么写只解决了你的iOS8的API跑到低版本的Xcode的时候不会报编译错误.
min的取值来自于你项目的deployment target, 即你的app愿意支持的最低版本. 从这个角度来说, 片段2写法只对做可移植的包的开发团队有用, 即不知道使用方会将deployment target设成几. 而没有这个需求的, 这种写法就浪费了,(因为假设自己的deployment是7.0,然后你想要在里面判断是7还是8来使用UIAlertViewController,还是UIAlertView。那么就是不可行的。因为deployment都是7,不管是7还是8的系统,出来的结果都是7,所以你始终使用的是UIALertView) 即你既然设定了最低支持iOS6, 那么还写一段代码来判断如果最低支持iOS7的情况下应该怎么做干嘛呢?

    //使用Xcode8,再把target设成9.0,下面代码会打印出100000 90000
    NSLog(@"%d",__IPHONE_OS_VERSION_MAX_ALLOWED);
    NSLog(@"%d",__IPHONE_OS_VERSION_MIN_REQUIRED);

那么我上面的问题(即我想使用新的API,但app又要支持旧的iOS版本)怎么解决? 组合!

  1. 我先判断编译环境, 以避免低版本SDK不认识高版本SDK的api, 造成编译错误(片段1)
  2. 在高版本SDK的条件内, 自行开始判断SDK版本, 或responedToSelector都可以,来判断是否使用高版本的api
  3. 在低版本条件内, 直接用低版本的API

片段2的场景很明确了,只针对最低的SDK版本写代码,这样使用你这个库的用户不管把deployment target设成几,都是看不到错误的, 只是, 这就使得这种代码执行起来, 永远用的是最旧的API

还是以UIAlertViewController来举例

#define IOS_VERSION_8_OR_LATER (([[[UIDevice currentDevice] systemVersion] floatValue] >=8.0)? (YES):(NO))
#if __IPHONE_OS_VERSION_MAX_ALLOWED >= __IPHONE_8_0//使用max,保证在Xcode5及以下也不会报错
    if(IOS_VERSION_8_OR_LATER){//8以后使用UIAletViewController
        UIAlertController *alertController = [[UIAlertController alloc] init];
    }else{//8以前使用UIAlertView
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"温馨提示" message:@"网络错误" delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
    }
#else
      UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"温馨提示" message:@"网络错误" delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
#endif

搞了半天,还是没消除警告 = =

参考资料:关于__IPHONE_OS_VERSION_MAX_ALLOWED和__IPHONE_OS_VERSION_MIN_ALLOWED的用法

  • 0
    点赞
  • 0
    评论
  • 0
    收藏
  • 一键三连
    一键三连
  • 扫一扫,分享海报

©️2020 CSDN 皮肤主题: 编程工作室 设计师:CSDN官方博客 返回首页
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值